"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Status = void 0;
const jsx_runtime_1 = require("react/jsx-runtime");
const react_1 = require("react");
const styled_1 = __importDefault(require("@emotion/styled"));
const common_1 = require("@workday/canvas-kit-react/common");
const Container = (0, styled_1.default)('div')(common_1.accessibleHide);
const Status = ({ ariaLive = 'polite', role = 'status', ariaRelevant = 'additions', expireMilliseconds = 500, announcementText = '', ariaAtomic, }) => {
    const [displayText, setDisplayText] = (0, react_1.useState)(announcementText);
    (0, react_1.useEffect)(() => {
        if (!announcementText) {
            return;
        }
        setDisplayText(announcementText);
        const clearText = setTimeout(() => setDisplayText(''), expireMilliseconds);
        return () => {
            clearTimeout(clearText);
        };
    }, [announcementText, expireMilliseconds]);
    return ((0, jsx_runtime_1.jsx)(Container, { "aria-live": ariaLive, role: role, "aria-relevant": ariaRelevant, "aria-atomic": ariaAtomic, children: displayText }));
};
exports.Status = Status;
