"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.searchThemes = exports.SearchTheme = void 0;
const common_1 = require("@workday/canvas-kit-react/common");
const tokens_1 = require("@workday/canvas-kit-react/tokens");
var SearchTheme;
(function (SearchTheme) {
    SearchTheme[SearchTheme["Light"] = 0] = "Light";
    SearchTheme[SearchTheme["Dark"] = 1] = "Dark";
    SearchTheme[SearchTheme["Transparent"] = 2] = "Transparent";
})(SearchTheme = exports.SearchTheme || (exports.SearchTheme = {}));
exports.searchThemes = {
    [SearchTheme.Transparent]: {
        background: 'rgba(0, 0, 0, 0)',
        backgroundFocus: 'rgba(0, 0, 0, 0)',
        color: tokens_1.colors.blackPepper300,
        colorFocus: tokens_1.colors.blackPepper300,
        placeholderColor: tokens_1.colors.licorice300,
        placeholderColorFocus: tokens_1.colors.licorice300,
        boxShadow: 'none',
        boxShadowFocus: 'none',
    },
    [SearchTheme.Light]: {
        background: tokens_1.colors.soap200,
        backgroundFocus: tokens_1.colors.soap200,
        backgroundHover: tokens_1.colors.soap300,
        color: tokens_1.colors.blackPepper300,
        placeholderColor: tokens_1.colors.licorice300,
        boxShadow: 'none',
        boxShadowFocus: (0, common_1.focusRing)().boxShadow,
    },
    [SearchTheme.Dark]: {
        background: 'rgba(0, 0, 0, 0.2)',
        backgroundFocus: tokens_1.colors.frenchVanilla100,
        color: tokens_1.colors.frenchVanilla100,
        colorFocus: tokens_1.colors.blackPepper300,
        placeholderColor: tokens_1.colors.frenchVanilla100,
        placeholderColorFocus: tokens_1.colors.licorice300,
        boxShadow: 'none',
    },
};
