import React from 'react';
import { ComboBoxMenuItemGroup } from './Combobox';
interface AutocompleteListProps {
    /**
     * The autocomplete items of the Combobox. This array of menu items is shown under the text input.
     */
    autocompleteItems: React.ReactElement<any>[] | ComboBoxMenuItemGroup[];
    /**
     * Index of the active autocomplete item
     */
    selectedIndex: number | null;
    /**
     * The function called when an autocomplete item is selected
     */
    handleAutocompleteClick: (event: React.SyntheticEvent<Element, Event>, menuItemProps: any) => void;
    /**
     * The id of the form field.
     */
    labelId: string;
    /**
     * The id of the combobox.
     */
    comboboxId: string;
    /**
     * True when group changes via keyboard control
     */
    showGroupText: boolean;
}
export declare const AutocompleteList: ({ autocompleteItems, comboboxId, selectedIndex, handleAutocompleteClick, labelId, showGroupText, }: AutocompleteListProps) => import("react/jsx-runtime").JSX.Element | null;
export {};
//# sourceMappingURL=AutocompleteList.d.ts.map