import { jsx as _jsx } from "react/jsx-runtime";
import { useState, useEffect } from 'react';
import styled from '@emotion/styled';
import { accessibleHide } from '@workday/canvas-kit-react/common';
const Container = styled('div')(accessibleHide);
export const Status = ({ ariaLive = 'polite', role = 'status', ariaRelevant = 'additions', expireMilliseconds = 500, announcementText = '', ariaAtomic, }) => {
    const [displayText, setDisplayText] = useState(announcementText);
    useEffect(() => {
        if (!announcementText) {
            return;
        }
        setDisplayText(announcementText);
        const clearText = setTimeout(() => setDisplayText(''), expireMilliseconds);
        return () => {
            clearTimeout(clearText);
        };
    }, [announcementText, expireMilliseconds]);
    return (_jsx(Container, { "aria-live": ariaLive, role: role, "aria-relevant": ariaRelevant, "aria-atomic": ariaAtomic, children: displayText }));
};
