import { focusRing } from '@workday/canvas-kit-react/common';
import { colors } from '@workday/canvas-kit-react/tokens';
export var SearchTheme;
(function (SearchTheme) {
    SearchTheme[SearchTheme["Light"] = 0] = "Light";
    SearchTheme[SearchTheme["Dark"] = 1] = "Dark";
    SearchTheme[SearchTheme["Transparent"] = 2] = "Transparent";
})(SearchTheme || (SearchTheme = {}));
export const searchThemes = {
    [SearchTheme.Transparent]: {
        background: 'rgba(0, 0, 0, 0)',
        backgroundFocus: 'rgba(0, 0, 0, 0)',
        color: colors.blackPepper300,
        colorFocus: colors.blackPepper300,
        placeholderColor: colors.licorice300,
        placeholderColorFocus: colors.licorice300,
        boxShadow: 'none',
        boxShadowFocus: 'none',
    },
    [SearchTheme.Light]: {
        background: colors.soap200,
        backgroundFocus: colors.soap200,
        backgroundHover: colors.soap300,
        color: colors.blackPepper300,
        placeholderColor: colors.licorice300,
        boxShadow: 'none',
        boxShadowFocus: focusRing().boxShadow,
    },
    [SearchTheme.Dark]: {
        background: 'rgba(0, 0, 0, 0.2)',
        backgroundFocus: colors.frenchVanilla100,
        color: colors.frenchVanilla100,
        colorFocus: colors.blackPepper300,
        placeholderColor: colors.frenchVanilla100,
        placeholderColorFocus: colors.licorice300,
        boxShadow: 'none',
    },
};
